<?php

/**  
 * Во втором параметре $links можно передать ссылки из которых будет построено облако, в формате: 
 * <a href="ссылка" style="font-size:12px;">анкор</a> <a href="ссылка2" style="font-size:12px;">анкор2</a>
 * v1.0
*/
function wp_cumulus_theme_flashcode( $options = array(), $links = '' ){
	$def_options = array(
		'width' => '550',        // ширина flash
		'height' => '375',       // высота flash
		'tcolor' => '3D3644',    // цвет больших ссылок
		'tcolor2' => '7E748C',   // цвет маленьких ссылок
		'hicolor' => 'DE1E1C',   // цвет наведенной ссылки
		'bgcolor' => '333333',   // цвет фона
		'speed' => '150',        // скорость вращения
		'trans' => 'false',      // прозрачный фон у flash
		'args' => '',            // аргументы передаваемые функции wp_tag_cloud. Пр.: largest=20&smallest=12&number=40
		'mode' => 'tags',        // отображать метки (tags), категории (cats) или и то и другое (both)
		'compmode' => 'js',      // режим вывода flash: js (javascript), пусто (object)
		'showwptags' => 1,    // показывать ли ссылки, если не работает flash
		'folder_url' => get_site_url() . str_replace(str_replace( '\\', '/', $_SERVER['DOCUMENT_ROOT']), '', str_replace( '\\', '/', dirname(__FILE__))) .'/' // путь до папки файла php
	);

	$options = array_merge($def_options, $options ? $options : array() );

	// определяем ссылки облака
	if( ! $links ){
		$taxonomy = "post_tag";
		if( $options['mode'] == 'cats' )
			$taxonomy = "category";
		elseif( $options['mode'] == 'both' )
			$taxonomy = array('post_tag','category');
		
		$args = wp_parse_args( $options['args'], array('taxonomy' => $taxonomy) );
		$args = array_merge($args, array( 'echo' => 0, 'format' => 'flat' )); // всегда echo=0&format=flat
		
		$links = wp_tag_cloud( $args );
	}
	$links = str_replace( "&nbsp;", " ", $links );
	
	// установим размер если его нет, для пострых ссылок
	if( $links && false === strpos($links, 'font-size:') ){
		$fSize = $options['font-size'] ? "style=\"font-size:{$options['font-size']}px;\"" : 'style="font-size:15px;"';
		$links = str_replace( "<a", "<a $fSize ", $links );
	}

	$folder_url = $options['folder_url'] ? $options['folder_url'] : plugins_url('wp-cumulus/');
	
	// add random seeds to so name and movie url to avoid collisions and force reloading (needed for IE)
	$foo .= 'so'. rand(0,99999);
	$movie .= $folder_url . 'tagcloud.swf';
	$js .= $folder_url . 'swfobject.js';
	$divname .= 'divname'.rand(0,999);
	
	$m_links = 'Для показа облака WP-Cumulus необходим <a href="http://www.adobe.com/go/getflashplayer" target="_blank" rel="nofollow">Flash Player 9</a> или выше.';
	$m_links = ( is_home() && !is_paged() ) ?  $m_links . ' <a href="http://wp-kama.ru">wp-kama.ru</a> - документация WordPress на русском.' : $m_links;
	
	// write flash tag
	if( $options['compmode'] == 'js' ){
		$out = '<!-- SWFObject embed by Geoff Stearns geoff@deconcept.com http://blog.deconcept.com/swfobject/ -->';	
		$out .= '<script type="text/javascript" src="'. $js .'"></script>';
		$out .= '<div class="wp-cumulus" style="text-align:center;" id="'. $divname .'">';
			// alternate content
			if( $options['showwptags'] ){
				$out .=  '<p>'. $links .'</p>';
			}
			$out .= '<p style="font-size:9px;">'. $m_links .'</p>';
		$out .= '</div>';
		
		$out .= '<script type="text/javascript">';
			$out .= 'var '.$foo.' = new SWFObject("'.$movie.'", "tagcloudflash", "'.$options['width'].'", "'.$options['height'].'", "9", "#'.$options['bgcolor'].'");';
			if( $options['trans'] == 'true' ){
				$out .= $foo.'.addParam("wmode", "transparent");';
			}
			$out .= $foo .'.addParam("allowScriptAccess", "always");';
			$out .= $foo .'.addVariable("tcolor", "0x'. $options['tcolor'] .'");';
			$out .= $foo .'.addVariable("tcolor2", "0x' . ($options['tcolor2'] == "" ? $options['tcolor'] : $options['tcolor2']) . '");';
			$out .= $foo .'.addVariable("hicolor", "0x' . ($options['hicolor'] == "" ? $options['tcolor'] : $options['hicolor']) . '");';
			$out .= $foo .'.addVariable("tspeed", "'.$options['speed'].'");';
			$out .= $foo .'.addVariable("distr", "true");';
			$out .= $foo .'.addVariable("mode", "tags");';

			// put tags in flashvar
			$out .= $foo.'.addVariable("tagcloud", "'. urlencode('<tags>'. $links .'</tags>') .'");';
			
			$out .= $foo.'.write("'. $divname .'");';
		$out .= '</script>';
	}
 	else
	{
		$out = '<object type="application/x-shockwave-flash" data="'.$movie.'" width="'.$options['width'].'" height="'.$options['height'].'">';
		$out .= '<param name="movie" value="'.$movie.'" />';
		$out .= '<param name="bgcolor" value="#'.$options['bgcolor'].'" />';
		$out .= '<param name="AllowScriptAccess" value="always" />';
		if( $options['trans'] == 'true' ){
			$out .= '<param name="wmode" value="transparent" />';
		}
		$out .= '<param name="flashvars" value="';
		$out .= 'tcolor=0x'.$options['tcolor'];
		$out .= '&amp;tcolor2=0x'.$options['tcolor2'];
		$out .= '&amp;hicolor=0x'.$options['hicolor'];
		$out .= '&amp;tspeed='.$options['speed'];
		$out .= '&amp;distr=true';
		$out .= '&amp;mode=tags';
		// Свои ссылки вы облаке
		// put tags in flashvar

		$out .= '&amp;tagcloud='. urlencode('<tags>'. $links .'</tags>');

		$out .= '" />';
		
		// alternate content
		if( $options['showwptags'] ){
			$out .= '<p>'. $links .'</p>';
		}
		$out .= '<p style="font-size:9px;">'. $m_links .'</p>';
		
		$out .= '</object>';
	}

	return $out;
}
